/*
#ifdef __cplusplus
extern "C" {
#endif
*/
/* Replace "dll.h" with the name of your header */
#include <windows.h>

BOOL APIENTRY DllMain (HINSTANCE hInst     /* Library instance handle. */ ,
                       DWORD reason        /* Reason this function is being called. */ ,
                       LPVOID reserved     /* Not used. */ )
{
    switch (reason)
    {
      case DLL_PROCESS_ATTACH:
        break;

      case DLL_PROCESS_DETACH:
        break;

      case DLL_THREAD_ATTACH:
        break;

      case DLL_THREAD_DETACH:
        break;
    }

    /* Returns TRUE on success, FALSE on failure */
    return TRUE;
}

#define WIN32_LEAN_AND_MEAN
#define MT4_EXPFUNC __declspec(dllexport)


//+-----------------------------------------------------------------------------------------------------------------------------+
//|															MT4 DATA STRUCT							                            |
//+-----------------------------------------------------------------------------------------------------------------------------+
#pragma pack(push,1)
struct RateInfo { unsigned int ctm; double open; double low; double high; double close; double vol; };
struct MqlStr   {          int len; char   * string;												};
#pragma pack(pop)
//+-----------------------------------------------------------------------------------------------------------------------------+
MT4_EXPFUNC double _stdcall GetCloseValue( RateInfo* Rates,int MaximumRecords, int Iteration )
{
	return( Rates[MaximumRecords-Iteration-1].close );
}
MT4_EXPFUNC double _stdcall GetHighValue( RateInfo* Rates,int MaximumRecords, int Iteration )
{
	return( Rates[MaximumRecords-Iteration-1].high );
}
MT4_EXPFUNC void _stdcall GetSMAArray( RateInfo* Rates, int MaximumRecords, int Period, double Result[] )
{
	for( int i = 0; i < MaximumRecords; i++)
	{
		double Sum = 0.0;
		for( int k = 0; k < Period ; k++ )
		{
			Sum += Rates[MaximumRecords-i-1-k].close;
		}
		Result[MaximumRecords-i-1] = Sum / Period ;
	}
}
/*
#ifdef __cplusplus
}
#endif
*/
